"use strict";

const { distance, closest } = require("./index.js");
const levenshtein = require("js-levenshtein");

const rnd_string = (length) => {
  let result = "";
  for (let i = 0; i < length; i++) {
    result += String.fromCharCode(Math.floor(Math.random() * 0x10000));
  }
  return result;
}

const rnd_string_ascii = (length) => {
  let result = "";
  for (let i = 0; i < length; i++) {
    result += String.fromCharCode(Math.floor(Math.random() * 256));
  }
  return result;
}

const rnd_string_alpha = (length) => {
  let result = "";
  const chars = "ABCD"
  for (let i = 0; i < length; i++) {
    result += chars[((Math.random() * chars.length) | 0) % chars.length];
  }
  return result;
}


// Benchmark
// let b = 0;
// console.time('test');
// for (let i = 0; i < 1000000; i++) {
//   const rnd_num1 = 32
//   const rnd_num2 = 32
//   const rnd_string1 = makeid(rnd_num1);
//   const rnd_string2 = makeid(rnd_num2);
//   const actual = distance(rnd_string1, rnd_string2);
//   b += actual;
// }
// console.timeEnd('test');
// console.log(b)

// Test
for (let i = 0; i < Infinity; i++) {
  if (i % 10000 === 0) console.log(i)
  const max_len = 100;
  const rnd_num1 = (Math.random() * max_len) | 0;
  const rnd_num2 = (Math.random() * max_len) | 0;
  const rnd_num3 = (Math.random() * max_len) | 0;
  const rnd_num4 = (Math.random() * max_len) | 0;
  const rnd_num5 = (Math.random() * max_len) | 0;
  const rnd_num6 = (Math.random() * max_len) | 0;
  const rnd_string1 = rnd_string(rnd_num1);
  const rnd_string2 = rnd_string(rnd_num2);
  const rnd_string3 = rnd_string(rnd_num3);
  const rnd_string4 = rnd_string(rnd_num4);
  const rnd_string5 = rnd_string(rnd_num5);
  const rnd_string6 = rnd_string(rnd_num6);
  const actual1 = distance(rnd_string1, rnd_string2);
  const expected1 = levenshtein(rnd_string1, rnd_string2);
  const actual2 = distance(rnd_string3, rnd_string4);
  const expected2 = levenshtein(rnd_string3, rnd_string4);
  const actual3 = distance(rnd_string5, rnd_string6);
  const expected3 = levenshtein(rnd_string5, rnd_string6);
  if (actual1 !== expected1) {
    console.log(rnd_string1)
    console.log(rnd_string2)
  }
  if (actual2 !== expected2) {
    console.log(rnd_string1)
    console.log(rnd_string2)
  }
  if (actual3 !== expected3) {
    console.log(rnd_string1)
    console.log(rnd_string2)
  }
}


// test("test compare", () => {
//   for (let i = 0; i < 1000; i++) {
//     const rnd_num1 = (Math.random() * 1000) | 0;
//     const rnd_num2 = (Math.random() * 1000) | 0;
//     const rnd_string1 = makeid(rnd_num1);
//     const rnd_string2 = makeid(rnd_num2);
//     const actual = distance(rnd_string1, rnd_string2);
//     const expected = levenshtein(rnd_string1, rnd_string2);
//     expect(actual).toBe(expected);
//   }
// });

// test("test find", () => {
//   const actual = closest("fast", ["slow", "faster", "fastest"]);
//   const expected = "faster";
//   expect(actual).toBe(expected);
// });
